/*
 * Temporary Bitmap Overlays for the GUI - header file
 *
 * Written and Copyright 1999 by David E. Down the Faery Monarch, Gonksoftware
 * This software is released under the GNU LGPL version 2.
 *
 * See the file "COPYING.LIB" for software license details.
 */

#define MAX_GUI_TBMOS 8 /* Set this to eight */

extern int tbmo_num;      /* Number of overlays are on screen */
extern int tbmo_handle[]; /* Handle Number Array */
extern bool overlayson;   /* Are the overlays on-screen */

 typedef struct {
  BITMAP *overlay, *background; /* Overlay and background bitmaps */
  int x, y;         /* The location on physical screen */
  int h, v;         /* The size of bitmap on screen */
  int px;           /* ox = point at window, perferred x offset from ox */
  int pya, pyb;     /* perferred above y, and below y locations */
  bool above;       /* Is above oy perferred */
  bool ownbitmap;   /* Uses its own overlay bitmap? */
  int handle;       /* The relative window */
 } GUI_TBMO_STRUCT;

extern GUI_TBMO_STRUCT tbmo_data[]; /* Overlay Data Array */

/* Place an overlay on the screen */
int place_overlay (BITMAP *bitmap, int handle, int x, int ya, int yb,
                   int h, int v, bool above, bool copy, bool blitnow);
/* Blit the temporary bitmap overlay on screen -- There is no prepare to
   draw TBMO routines */
void blit_tbmo (int ovrly_hnd);

/* Get the pointer for a bitmap overlay */
BITMAP *overlay_bitmap (int ovrly_hnd);

/* Get the mouse position that is on the overlay */
bool get_mouse_on_overlay (int ovrly_hnd, int *x, int *y);

/* Temporary hide all TBMOs */
void temporary_hide_tbmos ();

/* Redraw all TBMOs that were hiden */
void redraw_all_tbmos ();

/* Destroy an overlay */
bool destroy_overlay (int ovrly_hnd);

