/*
 * MagicTutu GUI dialog routines - Code
 *
 * Written and Copyright 1999 by David E. Down the Faery Monarch, Gonksoftware
 * This software is released under the GNU LGPL version 2.
 *
 * See the file "COPYING.LIB" for software license details.
 */

#include "def.h" /* Also defines the Hide / Unhides */
#define gui_dialog_rate 0x4000 /* Service dialog focus at each 0x5D37 ticks */

 typedef struct {
   DIALOG_INFO  *info;
   DIALOG_DATA  *data;
  } DIALOG_STRUCT;

/* Draw the GUI button */
void gui_button (BITMAP *bitmap, int x, int y, int h, int v, char *text) {
 int ycen = y + ((v - biosfontheight) >> 1);

#ifdef DEBUG_GUI
  fprintf(stderr, "gui.c: gui_button is being executed at: %U\n", gui_timer);
  fprintf(stderr, "       ... with text \"%s\" \n", text);
#endif

  rectfill (bitmap, x + 5, y + 5, x + h - 6, y + v - 6, clrsh_guibutton);
  vline (bitmap, x, y, y + v - 1, clrsh_guiotlnii);
  hline (bitmap, x, y, x + h - 1, clrsh_guiotlnii);
  vline (bitmap, x + h - 1, y, y + v - 1, clrsh_guioutlin);
  hline (bitmap, x, y + v - 1, x + h - 1, clrsh_guioutlin);
  vline (bitmap, x + 1, y + 1, y + v - 2, clrsh_guioutlin);
  vline (bitmap, x + 2, y + 2, y + v - 3, clrsh_guioutlin);
  vline (bitmap, x + 3, y + 3, y + v - 4, clrsh_guioutlin);
  vline (bitmap, x + 4, y + 4, y + v - 5, clrsh_guioutlin);
  hline (bitmap, x + 1, y + 1, x + h - 2, clrsh_guioutlin);
  hline (bitmap, x + 2, y + 2, x + h - 3, clrsh_guioutlin);
  hline (bitmap, x + 3, y + 3, x + h - 4, clrsh_guioutlin);
  hline (bitmap, x + 4, y + 4, x + h - 5, clrsh_guioutlin);
  vline (bitmap, x + h - 2, y + 1, y + v - 2, clrsh_guiotlnii);
  vline (bitmap, x + h - 3, y + 2, y + v - 3, clrsh_guiotlnii);
  vline (bitmap, x + h - 4, y + 3, y + v - 4, clrsh_guiotlnii);
  vline (bitmap, x + h - 5, y + 4, y + v - 5, clrsh_guiotlnii);
  hline (bitmap, x + 1, y + v - 2, x + h - 2, clrsh_guiotlnii);
  hline (bitmap, x + 2, y + v - 3, x + h - 3, clrsh_guiotlnii);
  hline (bitmap, x + 3, y + v - 4, x + h - 4, clrsh_guiotlnii);
  hline (bitmap, x + 4, y + v - 5, x + h - 5, clrsh_guiotlnii);
  text_mode (-1);
  textout_centre (bitmap, biosfont, text, x + (h >> 1), ycen, clrsh_guibuttxt);
 }

/* Put a focus on a GUI button */
void gui_button_focus (BITMAP *bitmap, int x, int y, int h, int v, char *text) {
 int ycen = y + ((v - biosfontheight) >> 1);

#ifdef DEBUG_GUI
  fprintf(stderr, "gui.c: gui_button_focus is being executed at: %U\n", gui_timer);
  fprintf(stderr, "       ... with text \"%s\" \n", text);
#endif

  rectfill (bitmap, x + 5, y + 5, x + h - 6, y + v - 6, clrsh_fguibtbod);
  vline (bitmap, x, y, y + v - 1, clrsh_fguiotlii);
  hline (bitmap, x, y, x + h - 1, clrsh_fguiotlii);
  vline (bitmap, x + h - 1, y, y + v - 1, clrsh_fguiotlin);
  hline (bitmap, x, y + v - 1, x + h - 1, clrsh_fguiotlin);
  vline (bitmap, x + 1, y + 1, y + v - 2, clrsh_fguiotlin);
  vline (bitmap, x + 2, y + 2, y + v - 3, clrsh_fguiotlin);
  vline (bitmap, x + 3, y + 3, y + v - 4, clrsh_fguiotlin);
  vline (bitmap, x + 4, y + 4, y + v - 5, clrsh_fguiotlin);
  hline (bitmap, x + 1, y + 1, x + h - 2, clrsh_fguiotlin);
  hline (bitmap, x + 2, y + 2, x + h - 3, clrsh_fguiotlin);
  hline (bitmap, x + 3, y + 3, x + h - 4, clrsh_fguiotlin);
  hline (bitmap, x + 4, y + 4, x + h - 5, clrsh_fguiotlin);
  vline (bitmap, x + h - 2, y + 1, y + v - 2, clrsh_fguiotlii);
  vline (bitmap, x + h - 3, y + 2, y + v - 3, clrsh_fguiotlii);
  vline (bitmap, x + h - 4, y + 3, y + v - 4, clrsh_fguiotlii);
  vline (bitmap, x + h - 5, y + 4, y + v - 5, clrsh_fguiotlii);
  hline (bitmap, x + 1, y + v - 2, x + h - 2, clrsh_fguiotlii);
  hline (bitmap, x + 2, y + v - 3, x + h - 3, clrsh_fguiotlii);
  hline (bitmap, x + 3, y + v - 4, x + h - 4, clrsh_fguiotlii);
  hline (bitmap, x + 4, y + v - 5, x + h - 5, clrsh_fguiotlii);
  text_mode (-1);
  textout_centre (bitmap, biosfont, text, x + (h >> 1), ycen, clrsh_fguibttxt);
 }

/* Draw a GUI check box */
void gui_check (BITMAP *bitmap, int x, int y, int status) {
  rect (bitmap, x, y, x + 8, y + 8, clrsh_guichek_o);
  vline (bitmap, x + 9, y + 1, y + 9, clrsh_guichek_o);
  hline (bitmap, x + 1, y + 9, x + 9, clrsh_guichek_o);
  rectfill (bitmap,x + 1, y + 1, x + 7, y + 7, clrsh_guichek_b);
   if (status) {
    line (bitmap, x + 1, y + 1, x + 6, y + 6, clrsh_guichek_m);
    line (bitmap, x + 2, y + 1, x + 7, y + 6, clrsh_guichek_m);
    line (bitmap, x + 6, y + 1, x + 1, y + 6, clrsh_guichek_m);
    line (bitmap, x + 7, y + 1, x + 2, y + 6, clrsh_guichek_m);
   }
 }

/* Draw a GUI text entry bar */
void gui_text (BITMAP *bitmap, int x, int y, int h, int v, char *text) {
  int yy, th = biosfontheight;

  rect (bitmap, x, y, x + h - 2, y + v - 2, clrsh_guitext_o);
  vline (bitmap, x + h - 1, y + 1, y + v - 1, clrsh_guitext_o);
  hline (bitmap, x + 1, y + v - 1, x + h - 1, clrsh_guitext_o);
  rectfill (bitmap, x + 1, y + 1, x + h - 3, y + v - 3, clrsh_guitext_b);
  yy = 1 + ((v - 3 - th) / 2) + (th & 0x01);
  text_mode(-1);
  textout(bitmap, biosfont, text, x + 2, y + yy, clrsh_guitext_e);
 }

/* Put Focus to a text entry bar */
void gui_text_focus (BITMAP *bitmap, int x, int y, int h, int v, char *text, int cursor) {
  int yy, xx, th = biosfontheight;
  unsigned char ch[2] = {0, 0};

  rect (bitmap, x, y, x + h - 2, y + v - 2, clrsh_fguitexto);
  vline (bitmap, x + h - 1, y + 1, y + v - 1, clrsh_fguitexto);
  hline (bitmap, x + 1, y + v - 1, x + h - 1, clrsh_fguitexto);
  rectfill (bitmap, x + 1, y + 1, x + h - 3, y + v - 3, clrsh_fguitextb);
  yy = 1 + ((v - 3 - th) / 2) + (th & 0x01);
  text_mode(-1);
  textout(bitmap, biosfont, text, x + 2, y + yy, clrsh_fguitexte);
 /* Find Cursor Position */
  ch[0] = text [cursor]; text[cursor] = 0x00;
  xx = text_length (biosfont, text); text[cursor] = ch[0];
 /* Draw Cursor */
  if (!ch[0]) ch[0] = 0x20;
  text_mode(clrsh_fguitexte);
  textout(bitmap, biosfont, ch, x + xx + 2, y + yy, clrsh_fguitextb);
 }

/* Draw a GUI button box */
void gui_radio (BITMAP *bitmap, int x, int y, int status) {
  /*   0123456789
   * 0 ...****... The Appearance of the Radio Button
   * 1 ..*....*..
   * 2 .*......*.
   * 3 *..****..*
   * 4 *.******.*
   * 5 *.******.*
   * 6 *..****..*
   * 7 .*......*.
   * 8 ..*....*..
   * 9 ...****...
   */

  /* Draw the radio button outline */
   hline (bitmap, x + 3, y, x + 6, clrsh_guiradi_o);
   putpixel(bitmap, x + 2, y + 1, clrsh_guiradi_o);
    hline (bitmap, x + 3, y + 1, x + 6, clrsh_guiradi_b);
    putpixel(bitmap, x + 7, y + 1, clrsh_guiradi_o);
   putpixel(bitmap,x + 1, y + 2, clrsh_guiradi_o);
    hline (bitmap, x + 2, y + 2, x + 7, clrsh_guiradi_b);
    putpixel(bitmap,x+ 8, y + 2, clrsh_guiradi_o);
   vline (bitmap, x, y + 3, y + 6, clrsh_guiradi_o);
    rectfill (bitmap, x + 1, y + 3, x + 8, y + 6, clrsh_guiradi_b);
    vline (bitmap, x + 9, y + 3, y + 6, clrsh_guiradi_o);
   putpixel(bitmap, x + 1, y + 7, clrsh_guiradi_o);
    hline (bitmap, x + 2, y + 7, x + 7, clrsh_guiradi_b);
    putpixel(bitmap,x + 8, y + 7, clrsh_guiradi_o);
   putpixel (bitmap, x + 2, y + 8, clrsh_guiradi_o);
    hline (bitmap, x + 3, y + 8, x + 6, clrsh_guiradi_b);
    putpixel (bitmap, x + 7, y + 8, clrsh_guiradi_o);
   hline (bitmap, x + 3, y + 9, x + 6, clrsh_guiradi_o);
  /* Show status to the radio button */
   if (status) {
    hline (bitmap, x + 3, y + 3, x + 6, clrsh_guiradi_m);
    rectfill (bitmap, x + 2, y + 4, x + 7, y + 5, clrsh_guiradi_m);
    hline (bitmap, x + 3, y + 6, x + 6, clrsh_guiradi_m);
   }
 }

/* Put focus on a GUI check box */
void gui_check_focus (BITMAP *bitmap, int x, int y, int status) {
  rect (bitmap, x, y, x + 8, y + 8, clrsh_fguicheko);
  vline (bitmap, x + 9, y + 1, y + 9, clrsh_fguicheko);
  hline (bitmap, x + 1, y + 9, x + 9, clrsh_fguicheko);
  rectfill (bitmap,x + 1, y + 1, x + 7, y + 7, clrsh_fguichekb);
   if (status) {
    line (bitmap, x + 1, y + 1, x + 6, y + 6, clrsh_fguichekm);
    line (bitmap, x + 2, y + 1, x + 7, y + 6, clrsh_fguichekm);
    line (bitmap, x + 6, y + 1, x + 1, y + 6, clrsh_fguichekm);
    line (bitmap, x + 7, y + 1, x + 2, y + 6, clrsh_fguichekm);
   }
 }

/* Draw a GUI button box */
void gui_radio_focus (BITMAP *bitmap, int x, int y, int status) {

  /* Draw the radio button outline */
   hline (bitmap, x + 3, y, x + 6, clrsh_fguiradio);
   putpixel(bitmap, x + 2, y + 1, clrsh_fguiradio);
    hline (bitmap, x + 3, y + 1, x + 6, clrsh_fguiradib);
    putpixel(bitmap, x + 7, y + 1, clrsh_fguiradio);
   putpixel(bitmap,x + 1, y + 2, clrsh_fguiradio);
    hline (bitmap, x + 2, y + 2, x + 7, clrsh_fguiradib);
    putpixel(bitmap,x+ 8, y + 2, clrsh_fguiradio);
   vline (bitmap, x, y + 3, y + 6, clrsh_fguiradio);
    rectfill (bitmap, x + 1, y + 3, x + 8, y + 6, clrsh_fguiradib);
    vline (bitmap, x + 9, y + 3, y + 6, clrsh_fguiradio);
   putpixel(bitmap, x + 1, y + 7, clrsh_fguiradio);
    hline (bitmap, x + 2, y + 7, x + 7, clrsh_fguiradib);
    putpixel(bitmap,x + 8, y + 7, clrsh_fguiradio);
   putpixel (bitmap, x + 2, y + 8, clrsh_fguiradio);
    hline (bitmap, x + 3, y + 8, x + 6, clrsh_fguiradib);
    putpixel (bitmap, x + 7, y + 8, clrsh_fguiradio);
   hline (bitmap, x + 3, y + 9, x + 6, clrsh_fguiradio);
  /* Show status to the radio button */
   if (status) {
    hline (bitmap, x + 3, y + 3, x + 6, clrsh_fguiradim);
    rectfill (bitmap, x + 2, y + 4, x + 7, y + 5, clrsh_fguiradim);
    hline (bitmap, x + 3, y + 6, x + 6, clrsh_fguiradim);
   }
 }

/* Redraw the dialog window */
int dialog_redraw (int handle, void *value) {
 DIALOG_STRUCT *dialog = (DIALOG_STRUCT *) value;
 BITMAP *bitmap;
 int i = 0;
 char flag = TRUE;

#ifdef DEBUG_GUI
 fprintf(stderr, "gui.c: dialog_redraw is being executed for handle: %U at: %U\n", handle, gui_timer);
#endif

  draw_window (handle);
  bitmap = windata[handle].subbitmap;
  /* Draw Window's Contents */
   while (flag) {
     switch (dialog->data[i].type) {
      case 0: { flag = FALSE; break; }
      case 1: { /* Basic text */
       textout (bitmap, (FONT *) dialog->data[i].attrib,
                dialog->data[i].field, dialog->data[i].posx,
                dialog->data[i].posy, dialog->data[i].param);
        break; }
      case 2: { /* Centred Text */
       textout_centre (bitmap, (FONT *) dialog->data[i].attrib,
                       dialog->data[i].field, dialog->data[i].posx,
                       dialog->data[i].posy,  dialog->data[i].param);
        break; }
      case DIALOG_BUTTON: { /* GUI button */
         if (dialog->info->focus == i) {
          gui_button_focus (bitmap, dialog->data[i].posx,
                      dialog->data[i].posy, dialog->data[i].length,
                      dialog->data[i].depth, dialog->data[i].field);
         } else {
          gui_button (bitmap, dialog->data[i].posx,
                      dialog->data[i].posy, dialog->data[i].length,
                      dialog->data[i].depth, dialog->data[i].field);
         }
        break; }
      case DIALOG_CHECK: { /* GUI check */
        dialog->data[i].length = dialog->data[i].depth = 10; /* Set to fixed length */
         if (dialog->info->focus == i) {
          gui_check_focus (bitmap, dialog->data[i].posx,
                     dialog->data[i].posy, dialog->data[i].status);
         } else {
          gui_check (bitmap, dialog->data[i].posx,
                     dialog->data[i].posy, dialog->data[i].status);
         }
        break; }
      case DIALOG_RADIO: { /* GUI radio */
        dialog->data[i].length = dialog->data[i].depth = 10; /* Set to fixed length */
         if (dialog->info->focus == i) {
          gui_radio_focus (bitmap, dialog->data[i].posx,
                     dialog->data[i].posy, dialog->data[i].status);
         } else {
          gui_radio (bitmap, dialog->data[i].posx,
                     dialog->data[i].posy, dialog->data[i].status);
         }
        break; }
      case DIALOG_INPUT: { /* GUI text */
         if (dialog->info->focus == i) {
          gui_text_focus (bitmap, dialog->data[i].posx,
                    dialog->data[i].posy, dialog->data[i].length,
                    dialog->data[i].depth, dialog->data[i].field,
                    dialog->data[i].status);
         } else {
          gui_text (bitmap, dialog->data[i].posx,
                    dialog->data[i].posy, dialog->data[i].length,
                    dialog->data[i].depth, dialog->data[i].field);
         }
        break; }
      default: { return -1; } /* Unrecognized dialog field */
     }
    i++;
   } /* End Loop */

  blit_window (handle); /* Also, unhides mouse! */

 #ifdef DEBUG_GUI
  fprintf(stderr, "gui.c: dialog_redraw has redrawn window with handle %U at: %U\n", handle, gui_timer);
 #endif
  return 0;
 }

/* simple dialog window close -- Can be inserted in Dialog array */
int simple_dialog_close (int handle, DIALOG_INFO *info, DIALOG_DATA *data) {
 int parent = windata[handle].parent;
 /* De-malloc the window resources */
#ifdef DEBUG_GUI
 fprintf(stderr, "gui.c: simple_dialog_close is being executed for handle: %U at: %U\n", handle, gui_timer);
#endif

  /* Unlock the parent is required */
   if (parent >= 0) {
    if (windata[parent].lock >= 0) {
     change_window_locks (FALSE, parent, handle);
    }
   }
  free(info);
  free(data);
  return 0; /* Complete close is permitted */
 }

/* This function prepares the simple dialog open */
int simple_dialog_open_sze (int parent, int x, int y, bool lock, DIALOG_INFO *info, DIALOG_DATA *data, size_t dialog_data_size) {
 DIALOG_DATA  *d_data;
 DIALOG_INFO  *d_info;
 int handle;

#ifdef DEBUG_GUI
 fprintf(stderr, "gui.c: simple_dialog_open is being executed for parent: %U at: %U\n", parent, gui_timer);
#endif

 /* Copy the Array (via some marcos) */
  d_info = malloc(sizeof (DIALOG_INFO));
  if (d_info == NULL) { return -1; }
  memcpy (d_info, info, sizeof (DIALOG_INFO));

  d_data = malloc(dialog_data_size);
  if (d_data == NULL) { free (d_info); return -1; }
  memcpy (d_data, data, dialog_data_size);

 /* Call the Dialog Routine */
  if ((handle = open_dialog (parent, x, y, d_info, d_data)) < 0) {
    free(d_info); free(d_data);
    return -1;
   }
   if (lock && parent >= 0) { /* Lock the parent if specified */
    change_window_locks (TRUE, parent, handle);
   }
  return handle;
 }

/* Close the dialog window */
int dialog_close (int handle, void *value) {
  DIALOG_STRUCT *dialog = (DIALOG_STRUCT *) value; /* Get dialog information */
  int i = 0;

  /* Find the last item */
  while (dialog->data[i].type) { i++; } /* Find the zero entry */
  if (dialog->data[i].proc == NULL) return -1; /* Can not be closed */
   if (dialog->data[i].proc (handle, dialog->info, dialog->data)) {
    return -1; /* Can not be closed */
   } else {
    free(value);
    return 0;  /* Now, the window can be closed completely */
   }

 }

/* The "S" icon on the dialog box -- Similar to the Close routine */
int dialog_special (int handle, void *value) {
  DIALOG_STRUCT *dialog = (DIALOG_STRUCT *) value; /* Get dialog information */
  int i = 0;

  /* Find the last item */
  while (dialog->data[i].type) { i++; } /* Find the zero entry */
  /* Add one for the special handle */
  i++;
  if (dialog->data[i].proc == NULL) return -1; /* Can not be closed */
   if (dialog->data[i].proc (handle, dialog->info, dialog->data)) {
    return -1; /* Can not be closed */
   } else {
    free(value);
    return 0;  /* Now, the window can be closed completely */
   }

 }

/* Get dialog focus (return TRUE if failure) */
bool dialog_focus_get (int handle, DIALOG_STRUCT *dialog, int i) {
   switch (dialog->data[i].type) {
    case DIALOG_BUTTON: { /* Put Focus on Button */
     if (!prepare_to_draw_win (handle)) {
      gui_button_focus (windata[handle].subbitmap, dialog->data[i].posx,
                        dialog->data[i].posy, dialog->data[i].length,
                        dialog->data[i].depth, dialog->data[i].field); }
     break; }
    case DIALOG_CHECK: { /* Put Focus on Check Box */
     if (!prepare_to_draw_win (handle)) {
      gui_check_focus (windata[handle].subbitmap, dialog->data[i].posx,
                       dialog->data[i].posy, dialog->data[i].status); }
     break; }
    case DIALOG_RADIO: { /* Put Focus on Radio Button */
     if (!prepare_to_draw_win (handle)) {
      gui_radio_focus (windata[handle].subbitmap, dialog->data[i].posx,
                       dialog->data[i].posy, dialog->data[i].status); }
     break; }
    case DIALOG_INPUT:  { /* Put Focus on Text */
     if (!prepare_to_draw_win (handle)) {
      gui_text_focus (windata[handle].subbitmap, dialog->data[i].posx,
                      dialog->data[i].posy, dialog->data[i].length,
                      dialog->data[i].depth, dialog->data[i].field,
                      dialog->data[i].status); }
     break; }
    default: { /* Can not focus */
     return TRUE; }
    }
  blit_sub_window(handle, dialog->data[i].posx, dialog->data[i].posy, dialog->data[i].length, dialog->data[i].depth);
  return FALSE;
 }

/* Remove dialog focus */
void dialog_focus_remove (int handle, DIALOG_STRUCT *dialog) {
 int focus = dialog->info->focus;

  if (focus >= 0) {
   if (!prepare_to_draw_win (handle)) {
     switch (dialog->data[focus].type) {
      case DIALOG_BUTTON: {
       gui_button (windata[handle].subbitmap, dialog->data[focus].posx,
                   dialog->data[focus].posy, dialog->data[focus].length,
                   dialog->data[focus].depth, dialog->data[focus].field);
       blit_sub_window(handle, dialog->data[focus].posx,
                       dialog->data[focus].posy, dialog->data[focus].length,
                       dialog->data[focus].depth);
       break; }
      case DIALOG_CHECK: {
       gui_check (windata[handle].subbitmap, dialog->data[focus].posx,
                  dialog->data[focus].posy, dialog->data[focus].status);
       blit_sub_window(handle, dialog->data[focus].posx,
                       dialog->data[focus].posy, dialog->data[focus].length,
                       dialog->data[focus].depth);
       break;}
      case DIALOG_RADIO: { /* GUI Radio Button */
       gui_radio (windata[handle].subbitmap, dialog->data[focus].posx,
                  dialog->data[focus].posy, dialog->data[focus].status);
       blit_sub_window(handle, dialog->data[focus].posx,
                       dialog->data[focus].posy, dialog->data[focus].length,
                       dialog->data[focus].depth);
       break;}
      case DIALOG_INPUT: {
       gui_text (windata[handle].subbitmap, dialog->data[focus].posx,
                 dialog->data[focus].posy, dialog->data[focus].length,
                 dialog->data[focus].depth, dialog->data[focus].field);
       blit_sub_window(handle, dialog->data[focus].posx,
                       dialog->data[focus].posy, dialog->data[focus].length,
                       dialog->data[focus].depth);
       break; }
     } /* switch */
    } /* if */
   dialog->info->focus = -1;
  } /* if (focus >= 0) */

 }

/* Dialog background control */
int dialog_thread (int handle, void *value) {
  DIALOG_STRUCT *dialog = (DIALOG_STRUCT *) value;
  int i = dialog->info->focus, x, y;

#ifdef DEBUG_GUI
 fprintf(stderr, "gui.c: dialog_thread is being executed for handle: %U at: %U\n", handle, gui_timer);
#endif

 /* Get the mouse */
  if (win_get_mouse(handle, &x, &y)) { if (i >= 0) x = y = -1; else return -1; }
 /* Check for focus */
  if (i < 0 ||
      x < dialog->data[i].posx ||
      x >= (dialog->data[i].posx + dialog->data[i].length) ||
      y < dialog->data[i].posy ||
      y >= (dialog->data[i].posy + dialog->data[i].depth)) {
    i = 0;
   /* !!! Find new focus !!! */
    while (dialog->data[i].type) {
     if ((x >= dialog->data[i].posx) &&
         (x < (dialog->data[i].posx + dialog->data[i].length)) &&
         (y >= dialog->data[i].posy) &&
         (y < (dialog->data[i].posy + dialog->data[i].depth))) {
       if (!dialog_focus_get(handle, dialog, i)) {
         if (dialog->info->focus >= 0)
          dialog_focus_remove (handle, dialog); /* Lost focus */
        dialog->info->focus = i; /* Inform about new focus */
        break;
       } // if
      } // if (is the cursor on an item)
     i++;
#if defined(DEBUG_GUI) || defined(DEBUG)
    if (key[KEY_ESC]) exit(255); /* Ye PANIC key */
#endif
     } // while
   } //if
  return 0;
 }

/* When the user hits enter or clicks a mouse
 * (Should be called at the end of a dialog routine)
 */
int dialog_doaction (int handle, DIALOG_STRUCT *dialog, int item) {
 int x, s;

  switch (dialog->data[item].type) {
    case DIALOG_BUTTON: {
      if (dialog->data[item].proc) {
       if (!dialog->data[item].proc (handle, dialog->info, dialog->data)) {
        /* Destroy value struct */
        free(dialog);
        /* Destroy the window */
        destroy_window(handle);
       }
      }
     break; }
    case DIALOG_CHECK: {
      dialog->data[item].status = !dialog->data[item].status;
      gui_check_focus (windata[handle].subbitmap, dialog->data[item].posx,
                       dialog->data[item].posy, dialog->data[item].status);
      blit_sub_window(handle, dialog->data[item].posx,
                      dialog->data[item].posy, dialog->data[item].length,
                      dialog->data[item].depth);
     break;}
    case DIALOG_RADIO: {
     s = dialog->data[item].param; x = 0; /* Get the series number */
      while (dialog->data[x].type) { /* Clear other radio buttons belonging to same series */
        if (dialog->data[x].type == DIALOG_RADIO &&
            dialog->data[x].param == s && dialog->data[x].status) {
         dialog->data[x].status = FALSE;
         gui_radio (windata[handle].subbitmap, dialog->data[x].posx,
                    dialog->data[x].posy, dialog->data[x].status);
         blit_sub_window(handle, dialog->data[x].posx,
                         dialog->data[x].posy, dialog->data[x].length,
                         dialog->data[x].depth);
         break;
        }
       x++;
      }
      dialog->data[item].status = TRUE;
      gui_radio_focus (windata[handle].subbitmap, dialog->data[item].posx,
                       dialog->data[item].posy, dialog->data[item].status);
      blit_sub_window(handle, dialog->data[item].posx,
                      dialog->data[item].posy, dialog->data[item].length,
                      dialog->data[item].depth);
     break;}
    default: {
     return -1; }
   }
  return 0;
 }

/* The Window Interaction for the Dialogs */
int dialog_interact (int handle, void *value) {
 DIALOG_STRUCT *dialog = (DIALOG_STRUCT *) value;
 int item, x ,y;

#ifdef DEBUG_GUI
 fprintf(stderr, "gui.c: dialog_interact is being executed for handle: %U at: %U\n", handle, gui_timer);
#endif
  win_get_mouse(handle, &x, &y);
   if ((item = dialog->info->focus) >= 0 && /* Check for vaild focus */
       (x >= dialog->data[item].posx) &&
       (x < (dialog->data[item].posx + dialog->data[item].length)) &&
       (y >= dialog->data[item].posy) &&
       (y < (dialog->data[item].posy + dialog->data[item].depth))) {
    dialog_doaction (handle, dialog, item); }
   timer_dclick = -1; mouse_dclick = 0; /* Do not enter double click mode */
  return 0;
 }

/* Activate a dialog */
int dialog_active (int handle, void *value) {

  dialog_thread (handle, value); /* Execute the thread */
  win_multithread (handle, dialog_thread, gui_dialog_rate); /* Start Threading */
  return 0;
 }

/* Deactive a dialog */
int dialog_inactive (int handle, void *value) {

  dialog_focus_remove (handle, (DIALOG_STRUCT *) value); /* remove focus */
  win_multithread (handle, NULL, 0); /* Disable threading */
  return 0;
 }

/* Dialog Keyboard Interactor */
int dialog_keyboard (int handle, void *value) {
 DIALOG_STRUCT *dialog = (DIALOG_STRUCT *) value;
 int x = read_convert_keyboard (), i, ii, xx, focx;
 char *input;

  bool change_focus () { /* Is the focus changeable */
   if (dialog_focus_get(handle, dialog, xx)) return TRUE;
   if (focx >= 0) { dialog_focus_remove (handle, dialog); }
   dialog->info->focus = xx;
   return FALSE;
  }

#ifdef DEBUG_GUI
 fprintf(stderr, "dialog_keyboard is being executed for handle: %U at: %U\n", handle, gui_timer);
#endif

  focx = dialog->info->focus;
   switch (x) {
    case (0x043e): { /* ALT-F4 key */
      if (!(windata[handle].flags & WF_NOCLOSE)) { /* Perform the formal close down */
        close_window (handle);
        return 0;
       }
     break; }
    case (0x0d): { /* The Enter Key */
      dialog_doaction (handle, dialog, focx);
     break; }
    case (0x09): {
     if ((xx = focx) < 0) xx = 0; else xx++; /* No Focus */
      for (;;) {
        if ((dialog->data[xx].type) == 0) {
          if (focx <= 0) break; else xx = 0;
         }
       if (!change_focus ()) break; /* Change focus if changeable */
       xx++;
       if (xx == focx) break;
      }
     break; }
    case (0x7e): { /* Might get this hotkey fixed up */
     xx = focx - 1;
      for (;;) {
        if (xx < 0) {
         for (xx = 0; dialog->data[xx].type; xx++) { } /* Dummy Loop */
         xx--;
        }
       if (!change_focus ()) break; /* Change focus if changeable */
       xx--;
       if (xx == focx) break;
      }
     break; }
   default: {
    if (dialog->data[focx].type == DIALOG_INPUT) {
     xx = strlen ((input = dialog->data[focx].field));
     /* I am having a hard time with variable casting */
     i = dialog->data[focx].status;
      if (x == 0x03) {
       input[0] = 0x00; i = 0;
      } else if (x == 0x08) { /* Backspace */
       if (i) {
        ii = (i -= 1);
         while (input[ii]) {
          input[ii] = input[ii + 1];
          ii++;
         }
        }
      } else if (x == 0x7f) { /* Delete */
       if (i < xx) {
        ii = i;
         while (input[ii]) {
          input[ii] = input[ii + 1];
          ii++;
         }
        }
      } else if (x >= ' ' && x <= 0xff) {
       if (xx == i) {
        if (xx < dialog->data[focx].param) {
         input[i++] = x;
         input[i] = 0x00;
        }
       } else {
        if (xx < dialog->data[focx].param) {
         ii = xx;
          while (ii >= i) {
           input[ii + 1] = input[ii];
           ii--;
          }
         input[i++] = x;
        }
       }
      } else if (x == 0x147) { /* Home */
       i = 0;
      } else if (x == 0x14b) { /* Left */
       if (i) i--;
      } else if (x == 0x14d) { /* Right */
       if (i < xx) i++;
      } else if (x == 0x14f) { /* End */
       i = xx;
      }
     dialog->data[focx].status = i;
     dialog_focus_get(handle, dialog, focx);
    } else {
     xx = (focx < 0 ? 0 : focx);
     if (x >= 'a' && x <= 'z') x -= 'a' - 'A'; /* equals 0x20 */
      for (;;) {
        if ((dialog->data[xx].type) == 0) {
          if (focx <= 0) break; else xx = 0;
         }
        if (dialog->data[xx].hotkey == x) { /* Has the hotkey been pressed */
         if (focx == xx) break;
          if (!change_focus ()) { /* Change focus if changeable */
           dialog_doaction (handle, dialog, xx);
           break;
          }
        }
       xx++;
       if (xx == focx) break;
      } /* while */
     } /* for */
    } /* if */
   } /* switch */
  return 0;
 }

/* Open up a Dialog window */
int open_dialog (int parent, int posx, int posy, DIALOG_INFO *info,
                 DIALOG_DATA *data) {
  int handle;
  DIALOG_STRUCT *value = (DIALOG_STRUCT *) malloc(sizeof(DIALOG_STRUCT));

#ifdef DEBUG_GUI
 fprintf(stderr, "gui.c: open_dialog is being executed for parent: %U at: %U\n", parent, gui_timer);
#endif

  if (deactive_window ()) return -1;
  info->focus = -1;
  value->info = info;
  value->data = data;
   if ((handle = allocate_window(posx, posy, info->szex, info->szey,
                                 parent, (info->flags | WF_CLSNOREACT),
                                 info->wintype, info->title, info->file,
                                 dialog_redraw, dialog_close, dialog_special,
                                 (void *) value)) < 0) {
    free(value);
    reactive_window ();
    return -1;
   }
  /* Do the activation */
  active_window (handle);

#ifdef DEBUG_GUI
  fprintf(stderr, "gui.c: open_dialog is setting hooks for handle: %U at: %U\n", handle, gui_timer);
#endif
  win_multithread (handle, dialog_thread, gui_dialog_rate); /* Currently, it won't fail */
  win_keyboard (handle, dialog_keyboard); /* Currently, it won't fail */
  win_interact (handle, dialog_interact); /* Currently, it won't fail */
  win_activities (handle, dialog_active, dialog_inactive); /* Currently. it won't fail */

  return handle;
 }
