/*
 * MagicTutu GUI dialog routines - Header
 *
 * Written and Copyright 1999 by David E. Down the Faery Monarch, Gonksoftware
 * This software is released under the GNU LGPL version 2.
 *
 * See the file "COPYING.LIB" for software license details.
 */

/* Dialog structures */
 typedef struct {
  char *title;    /* Window title */
  int szex, szey, /* Window size */
      flags,      /* Conditional flags */
      wintype;    /* Window type flag */
  void *value;    /* For applet specific information */
  char *file;     /* Filename */
  int focus;      /* Focus */
 } DIALOG_INFO;

 typedef struct DIALOG_DATA {
   int posx, posy, /* position on window */
       type,       /* Field Type */
       length,     /* Field Length */
       depth,      /* Field Depth */
       status,     /* Status Parameter (eg: Bullet Status */
       param;      /* First Field Parameter (eg: Bullet Series, or Colour) */
  void *field,     /* Field Data */
       *attrib;    /* Attribute Data */
  int  (*proc)(int handle, DIALOG_INFO *info, struct DIALOG_DATA *), /* The Procedure */
       hotkey;     /* Menu Hotkey Code */
 } DIALOG_DATA;

/* Dialog Defines */
#define DIALOG_BUTTON 4
#define DIALOG_CHECK  5
#define DIALOG_RADIO  6
#define DIALOG_INPUT  7

int simple_dialog_close (int handle, DIALOG_INFO *info, DIALOG_DATA *data); /* Simple dialog close */
int open_dialog (int parent, int posx, int posy, DIALOG_INFO *info,
                 DIALOG_DATA *data); /* Dialogs */
int simple_dialog_open_sze (int parent, int x, int y, bool lock, DIALOG_INFO *info, DIALOG_DATA *data, size_t dialog_data_size); /* Simple Dialog Open */

#define simple_dialog_open(parent,x,y,lock,info,data) \
        simple_dialog_open_sze(parent,x,y,lock,info,data,sizeof(data))
